/*
	Hyperion - A network anomaly discovery system
	Copyright (C) 2011 Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "config.h"
#include "error.hpp"

#ifndef FORMAT_HPP
#define FORMAT_HPP

//#include <string>

class DynamicValue;
class Format
{
	friend class DynamicValueFormat;
	public:
		Format();
		virtual std::string DoFormat(DynamicValue &v) = 0;
		
	private:
		unsigned int refcount;
};

class DynamicValueFormat
{
	public:
		DynamicValueFormat(const DynamicValueFormat &rhs);
		DynamicValueFormat &operator=(const DynamicValueFormat &rhs);
		DynamicValueFormat(Format *f = 0);
		~DynamicValueFormat();
		operator bool() const;
		std::string DoFormat(DynamicValue &v);
		
	private:
		Format *format;
};

DynamicValueFormat FormatIpv4();
DynamicValueFormat FormatMac();
DynamicValueFormat FormatHex(unsigned int n = 0);

#endif
