/*
	Hyperion - A network anomaly discovery system
	Copyright (C) 2012 Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "config.h"
#include "error.hpp"

#ifndef STRUCTURES_HPP
#define STRUCTURES_HPP

template <typename A, typename B> class ComparisonPair
{
	public:
		ComparisonPair(A pa, B pb)
		{
			a = pa;
			b = pb;
		}
		
		A GetA() const
		{
			return a;
		}
		
		B GetB() const
		{
			return b;
		}
		
		ComparisonPair<B, A> GetBA() const
		{
			return ComparisonPair<B, A>(b, a);
		}
		
		bool operator< (const ComparisonPair<A, B> &rhs) const
		{
			if (a < rhs.a){
				return true;
			}
			if (rhs.a < a){
				return false;
			}
			
			if (b < rhs.b){
				return true;
			}
			if (rhs.b < b){
				return false;
			}
			
			return false;
		}
		
	private:
		A a;
		B b;
};


#endif
