/*
	Hyperion - A network anomaly discovery system
	Copyright (C) 2011 Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "config.h"
#include "error.hpp"

#ifndef TIMER_HPP
#define TIMER_HPP

#include "event.hpp"
#include "module.hpp"
#include "time.hpp"

struct Timer
{
	Event e;
	Time t;
};

class TimerModule : public Module
{
	public:
		TimerModule(Modules *modules, EventManager *manager, Configuration *configuration, Database *database);
		Time ProcessTimers();
	private:
		void OnNewTimer(Event event);
		std::list<Timer> timers;
};

#endif
